<template>
  <div class="preorder-menu" v-if="!isMobile && preorderSections.length">
    <ul
      class="section-list"
      ref="sectionList"
      :style="{ 'max-height': menuHeight }"
    >
      <li
        class="section-item top-level"
        :class="{ active: 'timeSelector' === currentPreorderSection }"
      >
        <button
          class="section-button"
          @click="setChangePreorderSection({ key: 'timeSelector' })"
        >
          {{ $t(`${restaurantNavScope}.pickupTime`) }}
        </button>
      </li>
      <li
        class="section-item nested top-level"
        :class="{ active: 'timeSelector' !== currentPreorderSection }"
      >
        <button
          class="section-button"
          @click="setChangePreorderSection(preorderSections[0])"
        >
          {{ $t(`${restaurantNavScope}.order`) }}
        </button>
      </li>
      <li
        class="section-item"
        v-for="section in preorderSections"
        :ref="section.key"
        :key="section.key"
        :class="{
          active: section.key === currentPreorderSection,
          hide: 'timeSelector' === currentPreorderSection
        }"
      >
        <a
          :href="`#${section.name}`"
          class="section-button"
          @click="setChangePreorderSection(section)"
        >
          {{ section.name }}
        </a>
      </li>
    </ul>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";

export default {
  data() {
    return {
      menuHeight: "100%"
    };
  },

  computed: {
    ...mapState(["isMobile"]),
    ...mapState(["windowSize"]),
    ...mapState("restaurant", ["preorderSections", "currentPreorderSection"]),
    isPreorder() {
      return this.$route.name === "RestaurantPreorder";
    },
    isDelivery() {
      return this.$route.name === "RestaurantDelivery";
    },
    restaurantNavScope() {
      return this.isPreorder
        ? "restaurantPreorderNav"
        : this.isDelivery
        ? "restaurantDeliveryNav"
        : "";
    }
  },

  methods: {
    ...mapActions("restaurant", ["setChangePreorderSection"]),
    handleScroll() {
      const elem = this.$refs.sectionList;
      if (!elem || this.isMobile) return;
      const top = elem.getBoundingClientRect().top;
      const clientHeight = document.body.clientHeight;
      const height = clientHeight - top - 30;
      this.menuHeight = height + "px";
    },
    scrollMenuItem() {
      const elem =
        this.$refs[this.currentPreorderSection] &&
        this.$refs[this.currentPreorderSection][0];
      if (!elem || this.isMobile) return;
      elem.scrollIntoViewIfNeeded(false);
    }
  },
  watch: {
    windowSize() {
      this.handleScroll();
      this.$nextTick(() => {
        this.scrollMenuItem();
      });
    },
    currentPreorderSection() {
      this.scrollMenuItem();
    }
  },
  created() {
    window.addEventListener("scroll", this.handleScroll);
  },
  destroyed() {
    window.removeEventListener("scroll", this.handleScroll);
  }
};
</script>

<style lang="scss" scoped>
.preorder-menu {
  background: $color-white;
  padding: 28px 0 20px;
}

.section-list {
  margin: 0;
  padding: 0;
  list-style: none;
  overflow: auto;
  min-height: 100px;
}

.section-button {
  display: block;
  background: transparent;
  border: none;
  cursor: pointer;
  width: 100%;
  text-align: left;
  outline: none;
  padding: 0 0 0 37px;
  margin-bottom: 8px;
  color: $color-primary-black;
}

.section-item {
  line-height: 32px;
  border-left: 4px transparent solid;
  transition: border-color 0.4s;
  font-size: 16px;
  padding-left: 10px;

  &.top-level {
    font-size: 18px;
    padding-left: 0;
  }

  &.active {
    border-color: $color-skm-red;

    .section-button {
      font-weight: 500;
    }
  }

  &.nested {
    border-color: transparent;
    margin-top: 22px;
    margin-bottom: 12px;
  }

  &.hide {
    display: none;
  }
}
</style>
